//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPL
// copyright 2007
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[55];
 char filename[55];


/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}



//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];

  char indi_name[95];
  int  indi_name_t;

  char indi_bnote[95];
  int  indi_bnote_t;

  char indi_dnote[95];
  int  indi_dnote_t;

  char indi_buridate[90];
  int  indi_buridate_t;
  char indi_buriplace[90];
  int  indi_buriplace_t;

  char indi_deathdate[90];
  int  indi_deathdate_t;
  char indi_deathplace[90];
  int  indi_deathplace_t;


  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int label0,label1,label2,label3,label4,label5,label6;
  int label7,label8,label9,label10,label11, label12, label13;
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_buriplace," ");
  strcpy(indi_deathplace," ");
  strcpy(indi_deathdate," ");
  strcpy(indi_dnote," ");
  strcpy(indi_bnote," ");

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual - Death",500,400);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(35,18,490,360,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);

  label0 = gdx_label(argv[2],222,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  do{

    loopy++;

    //check for level 0

    fgets(input1,80,fp5);

    if (input1[0]=='0'){ //OK, we have a level 0
      //check for an individual
      //01234567890123
      //0 @I0001@ INDI

      if(input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){
        indi_found=1;
      }

      if(indi_found==1){
        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        //printf("check '%s' = '%s'\n",indi_check,argv[2]);
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          //now read in the individual's information
          do{

            fgets(input1,80,fp5);

            if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A'){     ///1 NAME
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_name,input1);
            }



// last actions

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A'){ //1 CHAN
               strcpy(last_action,"CHAN");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'){ //1 BURI
              strcpy(last_action,"BURI");
            }

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'){ //1 CREM
              strcpy(last_action,"CREM");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'){ //1 BIRT
               strcpy(last_action,"BIRT");
            }

            if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'){ //1 DEAT
              strcpy(last_action,"DEAT");
            }

// Burial Date and Death Date

           if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'){ //2 DATE
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buridate,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deathdate,input1);
              }
           }

// Brith Place and Death Place
 
           if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'){ //2 PLAC
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buriplace,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deathplace,input1);
              }
           }


// Buri Note and Death Note

           if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'){ //2 Note 
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='I'){
                strcpy(indi_bnote,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_dnote,input1);
              }
           }


          //stop when I get to the next idividual

          }while(input1[0] != '0' );

          flag1=22;
        }
      }//if indi

    }//if 0 level

    if(input1[0]=='\0'){

      flag1=22;
      gdx_label("File read error!",50,50,1);
      printf("NULL found!");
    }
   
  }while(flag1!=22);

  //display
  //Name
  label1 = gdx_label("Name:",40,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(125,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);


  //Burial Date
  label3=gdx_label("Burial Date:",40,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_buridate_t=gdx_textentry(125,150,100,0);
  gdx_settextentry(indi_buridate_t,indi_buridate);

  //Burial Place
  label4=gdx_label("Burial Place:",40,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_buriplace_t=gdx_textentry(125,175,350,0);
  gdx_settextentry(indi_buriplace_t,indi_buriplace);

  label12 = gdx_label("Burial Note:",40,210,0);
  gdx_setlabelbg("images/bg.xpm",1,label12);
  indi_bnote_t=gdx_textentry(125,200,350,0);
  gdx_settextentry(indi_bnote_t,indi_bnote);


  //Death Date
  label5=gdx_label("Death Date:",40,60,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_deathdate_t=gdx_textentry(125,50,100,0);
  gdx_settextentry(indi_deathdate_t,indi_deathdate);

  label6=gdx_label("Death Place:",40,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_deathplace_t=gdx_textentry(125,75,350,0);
  gdx_settextentry(indi_deathplace_t,indi_deathplace);

  label13 = gdx_label("Death Note:",40,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label13);
  indi_dnote_t=gdx_textentry(125,100,350,0);
  gdx_settextentry(indi_dnote_t,indi_dnote);


  gdx_main();
  x_close();

  return(0);
}

